include("doSkills.lua");
include("doGlobals.lua");
include("doClient.lua");
include("doThreading.lua");



winx,winy,winw,winh = windowRect(window);
winXCenter = winw/2 + winx;
winYCenter = winh/2 + winy;

CheckLeft 		= winXCenter - lootDistance * .8;
CheckRight 		= lootDistance * .8 + winXCenter;
CheckTop 			=	winYCenter - lootDistance * .6;
CheckBottom 	= lootDistance * .6 + winYCenter;		
printf("l:%d, r:%d, t:%d, b:%d",CheckLeft,CheckRight,CheckTop,CheckBottom);
CheckLoot = false;

stateSwitch = {
	["Idle"] 			= function ()
										print(">" .. playerInfo["state"]);
										local nextState = "Attack";
										repeat
											yrest(100);
											coroutine.yield();															
											if(keys["targetNext"]["keyModifyer"] ~= nil) and (keys["targetNext"]["vkey"] ~= nil)then
											  	keyboardPress( keys["targetNext"]["vkey"], keys["targetNext"]["keyModifyer"] )
											elseif (keys["targetNext"]["vkey"] ~= nil) then
													keyboardPress( keys["targetNext"]["vkey"])
											end			
											
										until (targetInfo.Health() == 1 and playerInfo.IsTargeting() == true and mobs:AttackThis(targetInfo.Name())==true)

										print("<" .. playerInfo["state"] .. " Changing to " .. nextState);
										playerInfo["state"] =nextState;
						 			end,
	["Attack"] 		= function ()
										print(">" .. playerInfo["state"]);
										local nextState = "CheckArea";
										repeat															
											for i,s in ipairs(skills["Attack"]) do
												if(mobs:AttackThis(targetInfo.Name())==true)then
													castSkill(s);
													yrest(100);
												end
											end
										--printf("Th:%.2f Ph:%.2f Pm:%.2f Pr:%.2f\r\n",  targetInfo.Health(),playerInfo.Health(),playerInfo.Mana() ,playerInfo.Rage())
										checkCaptcha();
										until (targetInfo.Health() <= 0 or playerInfo.IsTargeting() == false or mobs:AttackThis(targetInfo.Name())==false) 

										print("<" .. playerInfo["state"] .. " Changing to " .. nextState);
										playerInfo["state"] =nextState;
									end,
	["CheckArea"]	= function ()
										print(">" .. playerInfo["state"]);
										local nextState = "Rest";
										if(window == foregroundWindow())then
											winx,winy,winw,winh = windowRect(window);
											winXCenter = winw/2 + winx;
											winYCenter = winh/2 + winy;
											
											CheckLeft 		= winXCenter - lootDistance * .8;
											CheckRight 		= lootDistance * .8 + winXCenter;
											CheckTop 			=	winYCenter - lootDistance * .6;
											CheckBottom 	= lootDistance * .6 + winYCenter;								
											nextState = checkArea("Rest");
											if(nextState ~= "Rest")then
												CheckLoot = true;
											end
										end
										print("<" .. playerInfo["state"] .. " Changing to " .. nextState);
										playerInfo["state"] =nextState;
									end,										
	["Rest"] 			= function ()
										print(">" .. playerInfo["state"]);
										local nextState = "Buf";
										--printf("h: %1.2f m: %1.2f\r\n",playerInfo.Health(),playerInfo.Mana());
										if(((playerInfo["restHealth"]		~= 0) and	(playerInfo.Health() 	<= playerInfo["restHealth"])) 
											or ((playerInfo["restMana"]	~= 0) and	(playerInfo.Mana()		<= playerInfo["restMana"]	))) then  
											print("need rest");
											local done = false;
											for i,s in ipairs(skills["Rest"]) do	
												print(s["name"])								
												if(castSkill(s) == false) then
													done = true;
													nextState="CheckArea";
													break;
												end
												rest(100);
											end			
										end
										CheckLoot = true;
										print("<" .. playerInfo["state"] .. " Changing to " .. nextState);
										playerInfo["state"] =nextState;
									end,
	["Buf"]	= function ()
										print(">" .. playerInfo["state"]);
										local nextState = "Idle";
										for i,s in ipairs(skills["Buf"]) do
											castSkill(s);
											rest(30);
										end									
										print("<" .. playerInfo["state"] .. " Changing to " .. nextState);
										playerInfo["state"] =nextState;
									end,
																	
}
	
function botProcessing()  
		print ("Bot Procesing Thread Started"); 
  	while(true) do
  	print(playerInfo["state"]);
			stateSwitch[playerInfo["state"]]();
			coroutine.yield();
  	end    
end
        
function botLootProcessing()
		print ("BotLootThread Started");
  	while(true) do  
			if(window == foregroundWindow() and CheckLoot==true)then	
				for y=CheckBottom,CheckTop,-20 do
					for x=CheckRight,CheckLeft,-20 do
						if(petInfo.IsPetPopUp())then
							keyboardPress( key.VK_ESCAPE);
						end					
						mouseSet(x,y);
						coroutine.yield();
						rest(30);
						while(playerInfo.IsLooting()==false and systemInfo.CursorType()==5) do
							mouseRClick();
							rest(200);
						end
					end
				end 
				CheckLoot=false;	
			end	  
			coroutine.yield();
  	end    	
end        

function BoolToString(b)
	if(b==true)then
		return "true";
	else
		return "false";
	end
end

function main()

	showWindow(window, sw.show);
	print("**********  Validation testing");
	selectSelf();
	print("playerInfo.Name = " .. playerInfo.Name());
	print("playerInfo.Health = " .. playerInfo.Health());
	print("playerInfo.Mana = " .. playerInfo.Mana());
	print("playerInfo.Rage = " .. playerInfo.Rage());
	print("playerInfo.IsCasting = " .. BoolToString(playerInfo.IsCasting()));
	print("playerInfo.IsTargeting = " .. BoolToString(playerInfo.IsTargeting()));
	print("playerInfo.IsLooting = " .. BoolToString(playerInfo.IsLooting()));
	print("petInfo.Name = " .. petInfo.Name());
	print("petInfo.Health = " .. petInfo.Health());
	print("petInfo.IsPetPopUp = " .. BoolToString(petInfo.IsPetPopUp()));	
	print("targetInfo.Health = " .. targetInfo.Health());
	print("targetInfo.Name = " .. targetInfo.Name());
	print("targetInfo.IBoss = " .. BoolToString(targetInfo.IBoss()));
	print("systemInfo.CursorType = " .. systemInfo.CursorType());
	print("systemInfo.IsCaptcha = " .. BoolToString(systemInfo.IsCaptcha()));
	




	createThread(botProcessing);
  createThread(botLootProcessing);
	runThreads();
end

startMacro(main);








